#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "psapi.h"
#include <tlhelp32.h>


int main( int argc, char *argv[] );
void trace(HANDLE hProcess);
//void disassemble(unsigned int ops, unsigned int flags);
void disassemble(BYTE data2030000[]);

#define isBadHandle(h) ( (h) == NULL || (h) == INVALID_HANDLE_VALUE )

//VisualBoyAdvance addresses
unsigned int offset2030000=0;

#define aregOffset  0x00//offset2030000     //0x2E19EA0
#define xregOffset  0x04//offset2030000+0x04//0x2E19EA4
#define yregOffset  0x08//offset2030000+0x08//0x2E19EA8
#define dregOffset  0x0C//offset2030000+0x0C//0x2E19EAC
#define sregOffset  0x10//offset2030000+0x10//0x2E19EB0
#define pcOffset    0x14//offset2030000+0x14//0x2E19EB4
#define flagsOffset 0x18//offset2030000+0x18//0x2E19EB8
#define cycleOffset 0x1C//offset2030000+0x1C//0x2E19EBC
#define opsOffset   0x20//offset2030000+0x20//0x2E19EC0
#define romOffset   0x28//offset2030000+0x28//
#define frameOffset 0x2C//offset2030000+0x2C//0x2E19ECC

//global flags
short verbose=0;

int main( int argc, char *argv[] )
{
	int i, j;

	HANDLE hProcSnap;
	PROCESSENTRY32 ppe;
	HANDLE hProcess;

	for(i=1;i<argc;i++){
		if(strstr("-v",argv[i]))
			verbose=1;
	}

	hProcSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	ppe.dwSize = sizeof( PROCESSENTRY32 );
	Process32First( hProcSnap, &ppe );
	printf("Opening process");
	while ( Process32Next( hProcSnap, &ppe ) )
	{
		printf(".");
		//If this process matches argv[i]
		if ( (!stricmp( "VisualBoyAdvance.exe", ppe.szExeFile )) && stricmp(ppe.szExeFile,"[System Process]") )
		{
			hProcess = OpenProcess( PROCESS_VM_READ, 0, ppe.th32ProcessID );	
			if ( isBadHandle( hProcess ) )
				printf( "%s : OpenProcess() failed, err = %lu\n", ppe.szExeFile, GetLastError() );
			else
			{
				printf("Success!\nFinding offset");
				
				//find offset; relies on S reg and flags being at initial state
				for(i=0x2D00000; offset2030000==0; i+=102400){
					BYTE buffer[102400]={0};
					if(i>0x4000000){printf(" failed.\n");return -1;}
					ReadProcessMemory(hProcess, (void *)(i),&(buffer),102400,NULL);
					printf(".");
					for(j=0; j<102400; j++){
						//if S reg and flags are in initial state
						if (buffer[j]==0xFD && buffer[j+1]==0x01 && buffer[j+8]==0x36
							&& buffer[j+9]==0x01)
						{
							offset2030000=i+j-0x10;
							break;
						}
						//if LINE is in place...
						else if(buffer[j]==0x4c && buffer[j+1]==0x49 && buffer[j+2]==0x4e
							&& buffer[j+3]==0x45)
						{
							offset2030000=i+j-0x70;
						}
					}
				}//end find offset
				printf(" 0x%X\n\n",offset2030000);
				printf("- Begin Trace -\n\n");
				trace(hProcess);
				CloseHandle( hProcess );
			}
		}
	}
	if(hProcess==NULL)printf(" failed.\n");
	CloseHandle( hProcSnap );
	CloseHandle( hProcess );
	return 0;
}

void trace(HANDLE hProcess)
{
	//HWND vbahWnd;
	BYTE data2030000[0x30];
	unsigned int pc=0, prevPc=0;

	//vbahWnd=FindWindow(NULL,"VisualBoyAdvance");//"VisualBoyAdvance");
	//vbahWnd=FindWindow(NULL,"New Text Document.txt - Notepad");//"VisualBoyAdvance");
	//SendMessage(vbahWnd,WM_CLOSE,0,0);
	
	while (1) {
		ReadProcessMemory(hProcess, (void *)(offset2030000+pcOffset),&(pc),4,NULL);
		if(pc!=prevPc) {
			ReadProcessMemory(hProcess, (void *)(offset2030000),&(data2030000),0x30,NULL);

			printf("%08X: %02X%02X%02X%02X  ",pc,data2030000[opsOffset],data2030000[opsOffset+1],data2030000[opsOffset+2],data2030000[opsOffset+3]);
			disassemble(data2030000); 

			printf(" | A:%02X%02X X:%02X%02X Y:%02X%02X D:%02X%02X S:%02X%02X P:",data2030000[aregOffset+1],data2030000[aregOffset],data2030000[xregOffset+1],data2030000[xregOffset],data2030000[yregOffset+1],data2030000[yregOffset],data2030000[dregOffset+1],data2030000[dregOffset],data2030000[sregOffset+1],data2030000[sregOffset]);

			if(data2030000[flagsOffset]&0x80)printf("N");else printf("n");
			if(data2030000[flagsOffset]&0x40)printf("V");else printf("v");
			if(data2030000[flagsOffset]&0x20)printf("M");else printf("m");
			if(data2030000[flagsOffset]&0x10)printf("X");else printf("x");
			if(data2030000[flagsOffset]&0x08)printf("D");else printf("d");
			if(data2030000[flagsOffset]&0x04)printf("I");else printf("i");
			if(data2030000[flagsOffset]&0x02)printf("Z");else printf("z");
			if(data2030000[flagsOffset]&0x01)printf("C\n");else printf("c\n");

			if(verbose){
				printf("\nCycle:%02X%02X%02X%02X",data2030000[cycleOffset+3],data2030000[cycleOffset+2],data2030000[cycleOffset+1],data2030000[cycleOffset]);
				printf("\nFrame:%02X%02X",data2030000[frameOffset+1],data2030000[frameOffset]);
				printf("\nROM:%02X%02X%02X%02X",data2030000[romOffset+3],data2030000[romOffset+2],data2030000[romOffset+1],data2030000[romOffset]);
				printf("\n\n--------------------------------------------------------------------------------\n");
			}
			prevPc=pc;
		}
		Sleep(100);
		//SendMessage(vbahWnd, 0x07, 0, 0);
		//SendMessage(vbahWnd, 0x100, 'A', 0); 
		//SendMessage(vbahWnd, 0x102, 'A', 0); 
		//SendMessage(vbahWnd, 0x101, 'A', 0); 
		//keybd_event(0x41,0,0,0);
		//keybd_event(0x41,0,2,0);
	}
}

void disassemble(BYTE data2030000[])
{
	//BYTE operand[3]={ops>>8, ops>>16,ops>>24};
	BYTE flags=data2030000[flagsOffset];
	BYTE operand[3]={data2030000[opsOffset+1],data2030000[opsOffset+2],data2030000[opsOffset+3]};
	switch(data2030000[opsOffset])
	{
		case 0x00:printf("BRK $%02X    ",operand[0]); break;
		case 0x01:printf("ORA $%02X    ",operand[0]); break;
		case 0x02:printf("COP $%02X    ",operand[0]); break;
		case 0x03:printf("ORA $%02X    ",operand[0]); break;
		case 0x04:printf("TSB $%02X    ",operand[0]); break;
		case 0x05:printf("ORA $%02X    ",operand[0]); break;
		case 0x06:printf("ASL $%02X    ",operand[0]); break;
		case 0x07:printf("ORA $%02X    ",operand[0]); break;
		case 0x08:printf("PHP        "); break;
		case 0x09:{
			if(flags&0x20)printf("ORA #$%02X   ",operand[0]);
			else printf("ORA #$%02X%02X ",operand[1],operand[0]);
			break;}//may break on 16bit accumulator
		case 0x0A:printf("ASL        "); break;
		case 0x0B:printf("PHD        "); break;
		case 0x0C:printf("TSB $%02X%02X  ",operand[1],operand[0]); break;
		case 0x0D:printf("ORA $%02X%02X  ",operand[1],operand[0]); break;
		case 0x0E:printf("ASL $%02X%02X  ",operand[1],operand[0]); break;
		case 0x0F:printf("ORA $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0x10:printf("BPL $%02X    ",operand[0]); break;
		case 0x11:printf("ORA $%02X    ",operand[0]); break;
		case 0x12:printf("ORA $%02X    ",operand[0]); break;
		case 0x13:printf("ORA $%02X    ",operand[0]); break;
		case 0x14:printf("TRB $%02X    ",operand[0]); break;
		case 0x15:printf("ORA $%02X    ",operand[0]); break;
		case 0x16:printf("ASL $%02X    ",operand[0]); break;
		case 0x17:printf("ORA $%02X    ",operand[0]); break;
		case 0x18:printf("CLC        "); break;
		case 0x19:printf("ORA $%02X%02X  ",operand[1],operand[0]); break;
		case 0x1A:printf("INC        "); break;
		case 0x1B:printf("TCS        "); break;
		case 0x1C:printf("TRB $%02X%02X  ",operand[1],operand[0]); break;
		case 0x1D:printf("ORA $%02X%02X  ",operand[1],operand[0]); break;
		case 0x1E:printf("ASL $%02X%02X  ",operand[1],operand[0]); break;
		case 0x1F:printf("ORA $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0x20:printf("JSR $%02X%02X  ",operand[1],operand[0]); break;
		case 0x21:printf("AND $%02X    ",operand[0]); break;
		case 0x22:printf("JSR $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0x23:printf("AND $%02X    ",operand[0]); break;
		case 0x24:printf("BIT $%02X    ",operand[0]); break;
		case 0x25:printf("AND $%02X    ",operand[0]); break;
		case 0x26:printf("ROL $%02X    ",operand[0]); break;
		case 0x27:printf("AND $%02X    ",operand[0]); break;
		case 0x28:printf("PLP        "); break;
		case 0x29:{
			if(flags&0x20)printf("AND #$%02X   ",operand[0]); 
			else printf("AND #$%02X%02X ",operand[1],operand[0]);
			break;}//may break on 16bit accumulator
		case 0x2A:printf("ROL        "); break;
		case 0x2B:printf("PLD        "); break;
		case 0x2C:printf("BIT $%02X%02X  ",operand[1],operand[0]); break;
		case 0x2D:printf("AND $%02X%02X  ",operand[1],operand[0]); break;
		case 0x2E:printf("ROL $%02X%02X  ",operand[1],operand[0]); break;
		case 0x2F:printf("AND $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0x30:printf("BMI $%02X    ",operand[0]); break;
		case 0x31:printf("AND $%02X    ",operand[0]); break;
		case 0x32:printf("AND $%02X    ",operand[0]); break;
		case 0x33:printf("AND $%02X    ",operand[0]); break;
		case 0x34:printf("BIT $%02X    ",operand[0]); break;
		case 0x35:printf("AND $%02X    ",operand[0]); break;
		case 0x36:printf("ROL $%02X    ",operand[0]); break;
		case 0x37:printf("AND $%02X    ",operand[0]); break;
		case 0x38:printf("SEC        "); break;
		case 0x39:printf("AND $%02X%02X  ",operand[1],operand[0]); break;
		case 0x3A:printf("DEC        "); break;
		case 0x3B:printf("TSC        "); break;
		case 0x3C:printf("BIT $%02X%02X  ",operand[1],operand[0]); break;
		case 0x3D:printf("AND $%02X%02X  ",operand[1],operand[0]); break;
		case 0x3E:printf("ROL $%02X%02X  ",operand[1],operand[0]); break;
		case 0x3F:printf("AND $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0x40:printf("RTI        "); break;
		case 0x41:printf("EOR $%02X    ",operand[0]); break;
		case 0x42:printf("WDM $%02X    ",operand[0]); break;//|16 ?
		case 0x43:printf("EOR $%02X    ",operand[0]); break;
		case 0x44:printf("MVP $%02X%02X  ",operand[1],operand[0]); break;
		case 0x45:printf("EOR $%02X    ",operand[0]); break;
		case 0x46:printf("LSR $%02X    ",operand[0]); break;
		case 0x47:printf("EOR $%02X    ",operand[0]); break;
		case 0x48:printf("PHA        "); break;
		case 0x49:{
			if(flags&0x20)printf("EOR #$%02X   ",operand[0]); 
			else printf("EOR #$%02X%02X ",operand[1],operand[0]);
			break;}//may break on 16bit accumulator
		case 0x4A:printf("LSR        "); break;
		case 0x4B:printf("PHK        "); break;
		case 0x4C:printf("JMP $%02X%02X  ",operand[1],operand[0]); break;
		case 0x4D:printf("EOR $%02X%02X  ",operand[1],operand[0]); break;
		case 0x4E:printf("LSR $%02X%02X  ",operand[1],operand[0]); break;
		case 0x4F:printf("EOR $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0x50:printf("BVC $%02X    ",operand[0]); break;
		case 0x51:printf("EOR $%02X    ",operand[0]); break;
		case 0x52:printf("EOR $%02X    ",operand[0]); break;
		case 0x53:printf("EOR $%02X    ",operand[0]); break;
		case 0x54:printf("MVN $%02X%02X  ",operand[1],operand[0]); break;
		case 0x55:printf("EOR $%02X    ",operand[0]); break;
		case 0x56:printf("LSR $%02X    ",operand[0]); break;
		case 0x57:printf("EOR $%02X    ",operand[0]); break;
		case 0x58:printf("CLI        "); break;
		case 0x59:printf("EOR $%02X%02X  ",operand[1],operand[0]); break;
		case 0x5A:printf("PHY        "); break; 
		case 0x5B:printf("TCD        "); break;
		case 0x5C:printf("JMP $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0x5D:printf("EOR $%02X%02X  ",operand[1],operand[0]); break;
		case 0x5E:printf("LSR $%02X%02X  ",operand[1],operand[0]); break;
		case 0x5F:printf("EOR $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0x60:printf("RTS        "); break;
		case 0x61:printf("ADC $%02X    ",operand[0]); break;
		case 0x62:printf("PER $%02X%02X  ",operand[1],operand[0]); break;
		case 0x63:printf("ADC $%02X    ",operand[0]); break;
		case 0x64:printf("STZ $%02X    ",operand[0]); break;
		case 0x65:printf("ADC $%02X    ",operand[0]); break;
		case 0x66:printf("ROR $%02X    ",operand[0]); break;
		case 0x67:printf("ADC $%02X    ",operand[0]); break;
		case 0x68:printf("PLA        "); break;
		case 0x69:{
			if(flags&0x20)printf("ADC #$%02X   ",operand[0]); 
			else printf("ADC #$%02X%02X ",operand[1],operand[0]);
			break;}//may break on 16bit Accumultaor
		case 0x6A:printf("ROR        "); break;
		case 0x6B:printf("RTL        "); break;
		case 0x6C:printf("JMP $%02X%02X  ",operand[1],operand[0]); break;
		case 0x6D:printf("ADC $%02X%02X  ",operand[1],operand[0]); break;
		case 0x6E:printf("ROR $%02X%02X  ",operand[1],operand[0]); break;
		case 0x6F:printf("ADC $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0x70:printf("BVS $%02X    ",operand[0]); break;
		case 0x71:printf("ADC $%02X    ",operand[0]); break;
		case 0x72:printf("ADC $%02X    ",operand[0]); break;
		case 0x73:printf("ADC $%02X    ",operand[0]); break;
		case 0x74:printf("STZ $%02X    ",operand[0]); break;
		case 0x75:printf("ADC $%02X    ",operand[0]); break;
		case 0x76:printf("ROR $%02X    ",operand[0]); break;
		case 0x77:printf("ADC $%02X    ",operand[0]); break;
		case 0x78:printf("SEI        "); break;
		case 0x79:printf("ADC $%02X%02X  ",operand[1],operand[0]); break;
		case 0x7A:printf("PLY        "); break;
		case 0x7B:printf("TDC        "); break;
		case 0x7C:printf("JMP $%02X%02X  ",operand[1],operand[0]); break;
		case 0x7D:printf("ADC $%02X%02X  ",operand[1],operand[0]); break;
		case 0x7E:printf("ROR $%02X%02X  ",operand[1],operand[0]); break;
		case 0x7F:printf("ADC $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0x80:printf("BRA $%02X    ",operand[0]); break;
		case 0x81:printf("STA $%02X    ",operand[0]); break;
		case 0x82:printf("BRL $%02X%02X  ",operand[1],operand[0]); break;
		case 0x83:printf("STA $%02X    ",operand[0]); break;
		case 0x84:printf("STY $%02X    ",operand[0]); break;
		case 0x85:printf("STA $%02X    ",operand[0]); break;
		case 0x86:printf("STX $%02X    ",operand[0]); break;
		case 0x87:printf("STA $%02X    ",operand[0]); break;
		case 0x88:printf("DEY        "); break;
		case 0x89:{
			if(flags&0x20)printf("BIT #$%02X   ",operand[0]); 
			else printf("BIT #$%02X%02X ",operand[1],operand[0]);
			break;}//break on 16bit Accumultaor
		case 0x8A:printf("TXA        "); break;
		case 0x8B:printf("PHB        "); break;
		case 0x8C:printf("STY $%02X%02X  ",operand[1],operand[0]); break;
		case 0x8D:printf("STA $%02X%02X  ",operand[1],operand[0]); break;
		case 0x8E:printf("STX $%02X%02X  ",operand[1],operand[0]); break;
		case 0x8F:printf("STA $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0x90:printf("BCC $%02X    ",operand[0]); break;
		case 0x91:printf("STA $%02X    ",operand[0]); break;
		case 0x92:printf("STA $%02X    ",operand[0]); break;
		case 0x93:printf("STA $%02X    ",operand[0]); break;
		case 0x94:printf("STY $%02X    ",operand[0]); break;
		case 0x95:printf("STA $%02X    ",operand[0]); break;
		case 0x96:printf("STX $%02X    ",operand[0]); break;
		case 0x97:printf("STA $%02X    ",operand[0]); break;
		case 0x98:printf("TYA        "); break;
		case 0x99:printf("STA $%02X%02X  ",operand[1],operand[0]); break;
		case 0x9A:printf("TXS        "); break;
		case 0x9B:printf("TXY        "); break;
		case 0x9C:printf("STZ $%02X%02X  ",operand[1],operand[0]); break;
		case 0x9D:printf("STA $%02X%02X  ",operand[1],operand[0]); break;
		case 0x9E:printf("STZ $%02X%02X  ",operand[1],operand[0]); break;
		case 0x9F:printf("STA $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0xA0:{
			if(flags&0x10)printf("LDY #$%02X   ",operand[0]);
			else printf("LDY #$%02X%02X ",operand[1],operand[0]); 
			break;}//break on 8-bit index registers
		case 0xA1:printf("LDA $%02X    ",operand[0]); break;
		case 0xA2:{
			if(flags&0x10)printf("LDX #$%02X   ",operand[0]);
			else printf("LDX #$%02X%02X ",operand[1],operand[0]); 
			break;}//break on 8-bit index registers
		case 0xA3:printf("LDA $%02X    ",operand[0]); break;
		case 0xA4:printf("LDY $%02X    ",operand[0]); break;
		case 0xA5:printf("LDA $%02X    ",operand[0]); break;
		case 0xA6:printf("LDX $%02X    ",operand[0]); break;
		case 0xA7:printf("LDA $%02X    ",operand[0]); break;
		case 0xA8:printf("TAY        "); break;
		case 0xA9:{
			if(flags&0x20)printf("LDA #$%02X   ",operand[0]); 
			else printf("LDA #$%02X%02X ",operand[1],operand[0]);
			break;}//break on 16bit Accumultaor
		case 0xAA:printf("TAX        "); break;
		case 0xAB:printf("PLB        "); break;
		case 0xAC:printf("LDY $%02X%02X  ",operand[1],operand[0]); break;
		case 0xAD:printf("LDA $%02X%02X  ",operand[1],operand[0]); break;
		case 0xAE:printf("LDX $%02X%02X  ",operand[1],operand[0]); break;
		case 0xAF:printf("LDA $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0xB0:printf("BCS $%02X    ",operand[0]); break;
		case 0xB1:printf("LDA $%02X    ",operand[0]); break;
		case 0xB2:printf("LDA $%02X    ",operand[0]); break;
		case 0xB3:printf("LDA $%02X    ",operand[0]); break;
		case 0xB4:printf("LDY $%02X    ",operand[0]); break;
		case 0xB5:printf("LDA $%02X    ",operand[0]); break;
		case 0xB6:printf("LDX $%02X    ",operand[0]); break;
		case 0xB7:printf("LDA $%02X    ",operand[0]); break;
		case 0xB8:printf("CLV        "); break;
		case 0xB9:printf("LDA $%02X%02X  ",operand[1],operand[0]); break;
		case 0xBA:printf("TSX        "); break;
		case 0xBB:printf("TYX        "); break;
		case 0xBC:printf("LDY $%02X%02X  ",operand[1],operand[0]); break;
		case 0xBD:printf("LDA $%02X%02X  ",operand[1],operand[0]); break;
		case 0xBE:printf("LDX $%02X%02X  ",operand[1],operand[0]); break;
		case 0xBF:printf("LDA $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0xC0:{
			if(flags&0x10)printf("CPY #$%02X   ",operand[0]);
			else printf("CPY #$%02X%02X ",operand[1],operand[0]); 
			break;}//break on 8-bit index registers
		case 0xC1:printf("CMP $%02X    ",operand[0]); break;
		case 0xC2:printf("REP #$%02X   ",operand[0]); break;
		case 0xC3:printf("CMP $%02X    ",operand[0]); break;
		case 0xC4:printf("CPY $%02X    ",operand[0]); break;
		case 0xC5:printf("CMP $%02X    ",operand[0]); break;
		case 0xC6:printf("DEC $%02X    ",operand[0]); break;
		case 0xC7:printf("CMP $%02X    ",operand[0]); break;
		case 0xC8:printf("INY        "); break;
		case 0xC9:{
			if(flags&0x20)printf("CMP #$%02X   ",operand[0]); 
			else printf("CMP #$%02X%02X ",operand[1],operand[0]);
			break;}//break on 16bit Accumultaor
		case 0xCA:printf("DEX        "); break;
		case 0xCB:printf("WAI        "); break;
		case 0xCC:printf("CPY $%02X%02X  ",operand[1],operand[0]); break;
		case 0xCD:printf("CMP $%02X%02X  ",operand[1],operand[0]); break;
		case 0xCE:printf("DEC $%02X%02X  ",operand[1],operand[0]); break;
		case 0xCF:printf("CMP $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0xD0:printf("BNE $%02X    ",operand[0]); break;
		case 0xD1:printf("CMP $%02X    ",operand[0]); break;
		case 0xD2:printf("CMP $%02X    ",operand[0]); break;
		case 0xD3:printf("CMP $%02X    ",operand[0]); break;
		case 0xD4:printf("PEI $%02X    ",operand[0]); break;
		case 0xD5:printf("CMP $%02X    ",operand[0]); break;
		case 0xD6:printf("DEC $%02X    ",operand[0]); break;
		case 0xD7:printf("CMP $%02X    ",operand[0]); break;
		case 0xD8:printf("CLD        "); break;
		case 0xD9:printf("CMP $%02X%02X  ",operand[1],operand[0]); break;
		case 0xDA:printf("PHX        "); break;
		case 0xDB:printf("STP        "); break;
		case 0xDC:printf("JMP $%02X%02X  ",operand[1],operand[0]); break;
		case 0xDD:printf("CMP $%02X%02X  ",operand[1],operand[0]); break;
		case 0xDE:printf("DEC $%02X%02X  ",operand[1],operand[0]); break;
		case 0xDF:printf("CMP $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0xE0:{
			if(flags&0x10)printf("CPX #$%02X   ",operand[0]);
			else printf("CPX #$%02X%02X ",operand[1],operand[0]); 
			break;}//break on 8-bit index registers
		case 0xE1:printf("SBC $%02X    ",operand[0]); break;
		case 0xE2:printf("SEP #$%02X   ",operand[0]); break;
		case 0xE3:printf("SBC $%02X    ",operand[0]); break;
		case 0xE4:printf("CPX $%02X    ",operand[0]); break;
		case 0xE5:printf("SBC $%02X    ",operand[0]); break;
		case 0xE6:printf("INC $%02X    ",operand[0]); break;
		case 0xE7:printf("SBC $%02X    ",operand[0]); break;
		case 0xE8:printf("INX        "); break;
		case 0xE9:{
			if(flags&0x10)printf("SBC #$%02X   ",operand[0]);
			else printf("SBC #$%02X%02X ",operand[1],operand[0]); 
			break;}//break on 8-bit index registers
		case 0xEA:printf("NOP        "); break;
		case 0xEB:printf("XBA        "); break;
		case 0xEC:printf("CPX $%02X%02X  ",operand[1],operand[0]); break;
		case 0xED:printf("SBC $%02X%02X  ",operand[1],operand[0]); break;
		case 0xEE:printf("INC $%02X%02X  ",operand[1],operand[0]); break;
		case 0xEF:printf("SBC $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		case 0xF0:printf("BEQ $%02X    ",operand[0]); break;
		case 0xF1:printf("SBC $%02X    ",operand[0]); break;
		case 0xF2:printf("SBC $%02X    ",operand[0]); break;
		case 0xF3:printf("SBC $%02X    ",operand[0]); break;
		case 0xF4:printf("PEA $%02X%02X  ",operand[1],operand[0]); break;
		case 0xF5:printf("SBC $%02X    ",operand[0]); break;
		case 0xF6:printf("INC $%02X    ",operand[0]); break;
		case 0xF7:printf("SBC $%02X    ",operand[0]); break;
		case 0xF8:printf("SED        "); break;
		case 0xF9:printf("SBC $%02X%02X  ",operand[1],operand[0]); break;
		case 0xFA:printf("PLX        "); break;
		case 0xFB:printf("XCE        "); break;
		case 0xFC:printf("JSR $%02X%02X  ",operand[1],operand[0]); break;
		case 0xFD:printf("SBC $%02X%02X  ",operand[1],operand[0]); break;
		case 0xFE:printf("INC $%02X%02X  ",operand[1],operand[0]); break;
		case 0xFF:printf("SBC $%02X%02X%02X",operand[2],operand[1],operand[0]); break;
		default:printf("Error");break;
	}
}
